Index: issm/trunk/src/c/cores/masstransport_core.cpp
===================================================================
--- issm/trunk/src/c/cores/masstransport_core.cpp	(revision 25994)
+++ issm/trunk/src/c/cores/masstransport_core.cpp	(revision 26744)
@@ -9,6 +9,7 @@
 #include "../modules/modules.h"
 #include "../solutionsequences/solutionsequences.h"
-
-void masstransport_core(FemModel* femmodel){
+#include "../classes/Inputs/TransientInput.h"
+void SolidEarthIceUpdates(FemModel* femmodel);
+void masstransport_core(FemModel* femmodel){ /*{{{*/
 
 	/*Start profiler*/
@@ -64,5 +65,4 @@
 		InputDuplicatex(femmodel,BaseEnum,BaseOldEnum);
 		InputDuplicatex(femmodel,SurfaceEnum,SurfaceOldEnum);
-		InputDuplicatex(femmodel,SealevelriseCumDeltathicknessEnum,SealevelriseCumDeltathicknessOldEnum);
 		if(stabilization==4){
 			solutionsequence_fct(femmodel);
@@ -76,4 +76,6 @@
 			//}
 		}
+		SolidEarthIceUpdates(femmodel);
+
 		femmodel->parameters->SetParam(ThicknessEnum,InputToExtrudeEnum);
 		extrudefrombase_core(femmodel);
@@ -82,4 +84,5 @@
 		femmodel->parameters->SetParam(SurfaceEnum,InputToExtrudeEnum);
 		extrudefrombase_core(femmodel);
+
 	}
 
@@ -95,3 +98,62 @@
 	/*profiler*/
 	femmodel->profiler->Stop(MASSTRANSPORTCORE);
-}
+} /*}}}*/
+void SolidEarthIceUpdates(FemModel* femmodel){ /*{{{*/
+
+	int isgrd;
+	int grdmodel;
+	IssmDouble time;
+	int frequency,count;
+
+	/*retrieve parameters:*/
+	femmodel->parameters->FindParam(&isgrd,SolidearthSettingsGRDEnum);
+	femmodel->parameters->FindParam(&grdmodel,GrdModelEnum);
+	femmodel->parameters->FindParam(&time,TimeEnum);
+	femmodel->parameters->FindParam(&frequency,SolidearthSettingsRunFrequencyEnum);
+	femmodel->parameters->FindParam(&count,SealevelchangeRunCountEnum);
+
+	/*early return?:*/
+	if(!isgrd)return;
+
+	/*From old and new thickness, create delta thickness  and accumulate:*/
+	femmodel->inputs->ZAXPY(-1, ThicknessOldEnum,ThicknessEnum,DeltaIceThicknessEnum);
+	femmodel->inputs->AXPY(+1, DeltaIceThicknessEnum,AccumulatedDeltaIceThicknessEnum);
+
+	/*for Ivins deformation model, keep history of ice thickness changes inside TransientAccumulatedDeltaIceThicknessEnum:*/
+	if(grdmodel==IvinsEnum){
+
+		TransientInput* transientinput = femmodel->inputs->GetTransientInput(TransientAccumulatedDeltaIceThicknessEnum);
+
+		for(Object* & object : femmodel->elements->objects){
+			int *vertexlids = NULL;
+			int *vertexsids= NULL;
+			Element*   element=xDynamicCast<Element*>(object);
+			const int numvertices = element->GetNumberOfVertices();
+			IssmDouble* cumdeltathickness=NULL;
+
+			/*Get values and lid list and recover vertices ids needed to initialize inputs*/
+			vertexlids      = xNew<int>(numvertices);
+			vertexsids      = xNew<int>(numvertices);
+			cumdeltathickness=xNew<IssmDouble>(numvertices);
+			element->GetVerticesLidList(&vertexlids[0]);
+			element->GetVerticesSidList(&vertexsids[0]);
+			element->GetInputListOnVertices(&cumdeltathickness[0],AccumulatedDeltaIceThicknessEnum);
+
+			/*Add the current time cumdeltathickness to the existing time series: */
+			switch(element->ObjectEnum()){
+				case TriaEnum:  transientinput->AddTriaTimeInput( time,numvertices,vertexlids,cumdeltathickness,P1Enum); break;
+				default: _error_("Not implemented yet");
+			}
+			xDelete<int>(vertexlids);
+			xDelete<int>(vertexsids);
+			xDelete<IssmDouble>(cumdeltathickness);
+		}
+	}	
+
+	/*compute total ice thickness change between two sea-level solver time steps, ie. every frequency*dt:*/
+	if(count==frequency){
+		femmodel->inputs->ZAXPY(-1, OldAccumulatedDeltaIceThicknessEnum,AccumulatedDeltaIceThicknessEnum,DeltaIceThicknessEnum);
+		femmodel->inputs->DuplicateInput(AccumulatedDeltaIceThicknessEnum,OldAccumulatedDeltaIceThicknessEnum);
+	}
+	return;
+}/*}}}*/
Index: issm/trunk/src/c/cores/movingfront_core.cpp
===================================================================
--- issm/trunk/src/c/cores/movingfront_core.cpp	(revision 25994)
+++ issm/trunk/src/c/cores/movingfront_core.cpp	(revision 26744)
@@ -11,5 +11,5 @@
 
 void movingfront_core(FemModel* femmodel){
-	
+
 	/*Start profiler*/
 	femmodel->profiler->Start(MOVINGFRONTCORE);
@@ -47,5 +47,4 @@
 		}
 	}
-
 
 	/* start the work from here */
@@ -111,4 +110,6 @@
 	}
 
+	/* Calculate the frontal velocity for levelset function */
+	MovingFrontalVelx(femmodel);
 
 	/* solve level set equation */
@@ -132,10 +133,4 @@
 	GetMaskOfIceVerticesLSMx(femmodel);
 
-	/* add computation domain mask to outputs */
-	if(save_results){
-		int outputs[1] = {IceMaskNodeActivationEnum};
-		femmodel->RequestedOutputsx(&femmodel->results,&outputs[0],1);
-	}
-	
 	/*End profiler*/
 	femmodel->profiler->Stop(MOVINGFRONTCORE);
Index: issm/trunk/src/c/cores/oceantransport_core.cpp
===================================================================
--- issm/trunk/src/c/cores/oceantransport_core.cpp	(revision 26744)
+++ issm/trunk/src/c/cores/oceantransport_core.cpp	(revision 26744)
@@ -0,0 +1,89 @@
+/*!\file: oceantransport_core.cpp
+ * \brief: core of the oceantransport solution 
+ */ 
+
+#include "./cores.h"
+#include "../toolkits/toolkits.h"
+#include "../classes/classes.h"
+#include "../shared/shared.h"
+#include "../modules/modules.h"
+#include "../solutionsequences/solutionsequences.h"
+
+void SolidEarthOceanUpdates(FemModel* femmodel);
+void oceantransport_core(FemModel* femmodel){ /*{{{*/
+
+	/*Start profiler*/
+	femmodel->profiler->Start(OCEANTRANSPORTCORE);
+
+	/*parameters: */
+	int    numoutputs;
+	bool   save_results;
+	bool   dakota_analysis;
+	int    solution_type;
+	Vector<IssmDouble>*  ug  = NULL;
+
+	/*activate configuration*/
+	femmodel->SetCurrentConfiguration(OceantransportAnalysisEnum);
+
+	/*recover parameters: */
+	femmodel->parameters->FindParam(&save_results,SaveResultsEnum);
+	femmodel->parameters->FindParam(&solution_type,SolutionTypeEnum);
+
+	if(VerboseSolution()) _printf0_("   computing ocean mass transport\n");
+
+	femmodel->SetCurrentConfiguration(OceantransportAnalysisEnum);
+
+	/*save current bottom pressures before updating:*/
+	InputDuplicatex(femmodel,BottomPressureEnum,BottomPressureOldEnum);
+	InputDuplicatex(femmodel,DslEnum,DslOldEnum);
+	InputDuplicatex(femmodel,StrEnum,StrOldEnum);
+
+	/*grab bottom pressures, dsl and str from OceantransportSpcbottompressure, OceantransportSpcdslEnum 
+	 * and OceantransportSpcstrEnum  inputs in each element, assemble into a vector and feed to 
+	 * InputUpdateFromSolutionx which will deal with accumulating such inputs:*/
+	GetSolutionFromInputsx(&ug,femmodel); 
+	InputUpdateFromSolutionx(femmodel,ug); 
+
+	SolidEarthOceanUpdates(femmodel);
+
+	if(solution_type==OceantransportSolutionEnum)femmodel->RequestedDependentsx();
+
+	/*profiler*/
+	femmodel->profiler->Stop(OCEANTRANSPORTCORE);
+
+	/*free ressources:*/
+	delete ug;
+
+} /*}}}*/
+void SolidEarthOceanUpdates(FemModel* femmodel){ /*{{{*/
+
+	int isgrd;
+	int grdmodel;
+	IssmDouble time;
+	int frequency,count;
+
+	/*retrieve parameters:*/
+	femmodel->parameters->FindParam(&isgrd,SolidearthSettingsGRDEnum);
+	femmodel->parameters->FindParam(&grdmodel,GrdModelEnum);
+	femmodel->parameters->FindParam(&time,TimeEnum);
+	femmodel->parameters->FindParam(&frequency,SolidearthSettingsRunFrequencyEnum);
+	femmodel->parameters->FindParam(&count,SealevelchangeRunCountEnum);
+
+	/*early return?:*/
+	if(!isgrd)return;
+
+	/* From old and new bottom pressures, create delta bottom pressure, delta dsl and delta str. 
+	 * Accumulate delta bottom pressure: */
+	femmodel->inputs->ZAXPY(-1, BottomPressureOldEnum,BottomPressureEnum,DeltaBottomPressureEnum);
+	femmodel->inputs->AXPY(+1, DeltaBottomPressureEnum,AccumulatedDeltaBottomPressureEnum);
+
+	femmodel->inputs->ZAXPY(-1, DslOldEnum,DslEnum,DeltaDslEnum);
+	femmodel->inputs->ZAXPY(-1, StrOldEnum,StrEnum,DeltaStrEnum);
+
+	/* Compute total bottom pressure change between two sea-level solver time steps, ie. every frequency*dt. */
+	if(count==frequency){
+		femmodel->inputs->ZAXPY(-1, OldAccumulatedDeltaBottomPressureEnum,AccumulatedDeltaBottomPressureEnum,DeltaBottomPressureEnum);
+		femmodel->inputs->DuplicateInput(AccumulatedDeltaBottomPressureEnum,OldAccumulatedDeltaBottomPressureEnum);
+	}
+	return;
+}/*}}}*/
Index: issm/trunk/src/c/cores/sampling_core.cpp
===================================================================
--- issm/trunk/src/c/cores/sampling_core.cpp	(revision 26744)
+++ issm/trunk/src/c/cores/sampling_core.cpp	(revision 26744)
@@ -0,0 +1,48 @@
+/*!\file: sampling_core.cpp
+ * \brief: core of the sampling solution
+ */
+
+#include "../classes/classes.h"
+#include "../solutionsequences/solutionsequences.h"
+
+void sampling_core(FemModel* femmodel){
+
+	/*Start profiler*/
+	femmodel->profiler->Start(SAMPLINGCORE);
+
+	/*parameters: */
+	int    numoutputs;
+	bool   save_results;
+	int    solution_type;
+	char** requested_outputs = NULL;
+
+	/*activate configuration*/
+	femmodel->SetCurrentConfiguration(SamplingAnalysisEnum);
+
+	/*recover parameters: */
+	femmodel->parameters->FindParam(&save_results,SaveResultsEnum);
+	femmodel->parameters->FindParam(&solution_type,SolutionTypeEnum);
+	femmodel->parameters->FindParam(&numoutputs,SamplingNumRequestedOutputsEnum);
+	if(numoutputs) femmodel->parameters->FindParam(&requested_outputs,&numoutputs,SamplingRequestedOutputsEnum);
+
+	if(VerboseSolution()) _printf0_("   Generating random samples\n");
+
+	/*Generate random sample*/
+	if(VerboseSolution()) _printf0_("   call computational core\n");
+	femmodel->SetCurrentConfiguration(SamplingAnalysisEnum);
+	solutionsequence_sampling(femmodel);
+
+	if(save_results){
+		if(VerboseSolution()) _printf0_("   saving results\n");
+		int outputs = SampleEnum;
+		femmodel->RequestedOutputsx(&femmodel->results,&outputs,1);
+	}
+
+	if(solution_type==SamplingSolutionEnum)femmodel->RequestedDependentsx();
+
+	/*Free ressources:*/
+	if(numoutputs){for(int i=0;i<numoutputs;i++){xDelete<char>(requested_outputs[i]);} xDelete<char*>(requested_outputs);}
+
+	/*profiler*/
+	femmodel->profiler->Stop(SAMPLINGCORE);
+}
Index: issm/trunk/src/c/cores/sealevelchange_core.cpp
===================================================================
--- issm/trunk/src/c/cores/sealevelchange_core.cpp	(revision 25994)
+++ issm/trunk/src/c/cores/sealevelchange_core.cpp	(revision 26744)
@@ -2,4 +2,10 @@
  * \brief: core of the sea-level change solution 
  */ 
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
 
 #include "./cores.h"
@@ -13,7 +19,19 @@
 #include "../solutionsequences/solutionsequences.h"
 
+/*support routines local definitions:{{{*/
+void TransferForcing(FemModel* femmodel,int forcingenum);
+void TransferSealevel(FemModel* femmodel,int forcingenum);
+bool slcconvergence(Vector<IssmDouble>* RSLg,Vector<IssmDouble>* RSLg_old,IssmDouble eps_rel,IssmDouble eps_abs);
+IssmDouble  SealevelloadsOceanAverage(GrdLoads* loads, Vector<IssmDouble>* oceanareas, Vector<IssmDouble>* subelementoceanareas, IssmDouble totaloceanarea);
+void PolarMotion(IssmDouble* m, FemModel* femmodel,GrdLoads* loads, SealevelGeometry* slgeom);
+void ConserveOceanMass(FemModel* femmodel,GrdLoads* loads, IssmDouble offset, SealevelGeometry* slgeom);
+void ivins_deformation_core(FemModel* femmodel);
+IssmDouble* CombineLoads(IssmDouble* load,IssmDouble* subload,FemModel* femmodel, SealevelGeometry* slgeom,int loadtype,int nel);
+/*}}}*/
 
 /*main cores:*/
-void sealevelchange_core(FemModel* femmodel){ /*{{{*/
+void              sealevelchange_core(FemModel* femmodel){ /*{{{*/
+
+	SealevelGeometry* slgeom=NULL;
 
 	/*Start profiler*/
@@ -22,47 +40,31 @@
 	/*Parameters, variables:*/
 	bool save_results;
-	bool isslr=0;
-	bool isgia=0;
-	int  grd=0;
-	int solution_type;
 
 	/*Retrieve parameters:*/
-	femmodel->parameters->FindParam(&isslr,TransientIsslrEnum);
-	femmodel->parameters->FindParam(&solution_type,SolutionTypeEnum);
 	femmodel->parameters->FindParam(&save_results,SaveResultsEnum);
-	femmodel->parameters->FindParam(&grd,SolidearthSettingsGRDEnum); 
-
-	/*in case we are running SealevelriseSolutionEnum, then bypass transient settings:*/
-	if(solution_type==SealevelriseSolutionEnum){
-		isslr=1;
-		isgia=1;
-	}
-
-	/*Should we be here?:*/
-	if(!isslr)return;
 
 	/*Verbose: */
-	if(VerboseSolution()) _printf0_("   computing sea level rise\n");
-
-	/*Run gia core: */
-	if(isgia){
-		#ifdef _HAVE_GIA_
-		gia_core(femmodel);
-		#else
-		_error_("ISSM was not compiled with gia capabilities. Exiting");
-		#endif
-	}
+	if(VerboseSolution()) _printf0_("   computing sea level change\n");
 
 	/*set SLR configuration: */
-	femmodel->SetCurrentConfiguration(SealevelriseAnalysisEnum);
+	femmodel->SetCurrentConfiguration(SealevelchangeAnalysisEnum);
 
 	/*run geometry core: */
-	sealevelrise_core_geometry(femmodel);
+	slgeom=sealevelchange_geometry(femmodel);
+
+	/*any external forcings?:*/
+	solidearthexternal_core(femmodel);
+
+	/*Run coupler input transfer:*/
+	couplerinput_core(femmodel);
 
 	/*Run geodetic:*/
-	if(grd)grd_core(femmodel);
+	grd_core(femmodel,slgeom);
 
 	/*Run steric core for sure:*/
 	dynstr_core(femmodel);
+
+	/*Run coupler output transfer: */
+	coupleroutput_core(femmodel);
 
 	/*Save results: */
@@ -71,64 +73,101 @@
 		char **requested_outputs = NULL;
 		if(VerboseSolution()) _printf0_("   saving results\n");
-		femmodel->parameters->FindParam(&requested_outputs,&numoutputs,SealevelriseRequestedOutputsEnum);
+		femmodel->parameters->FindParam(&requested_outputs,&numoutputs,SealevelchangeRequestedOutputsEnum);
 		femmodel->RequestedOutputsx(&femmodel->results,requested_outputs,numoutputs);
 		if(numoutputs){for(int i=0;i<numoutputs;i++){xDelete<char>(requested_outputs[i]);} xDelete<char*>(requested_outputs);}
 	}
 
-	/*requested dependents: */
-	if(solution_type==SealevelriseSolutionEnum)femmodel->RequestedDependentsx();
-	
 	/*End profiler*/
 	femmodel->profiler->Stop(SLRCORE);
 }
 /*}}}*/
-void grd_core(FemModel* femmodel){ /*{{{*/
-
-	/*Gravity rotation deformation core GRD: */
+void              solidearthexternal_core(FemModel* femmodel){ /*{{{*/
 
 	/*variables:*/
-	Vector<IssmDouble> *RSLg    = NULL;
-	Vector<IssmDouble> *BPg    = NULL;
-	Vector<IssmDouble> *RSLg_rate    = NULL;
-	Vector<IssmDouble> *RSLg_eustatic  = NULL; 
-	Vector<IssmDouble> *U_esa  = NULL; 
-	Vector<IssmDouble> *U_esa_rate  = NULL; 
-	Vector<IssmDouble> *N_esa  = NULL; 
-	Vector<IssmDouble> *N_esa_rate  = NULL; 
-	Vector<IssmDouble> *U_north_esa   = NULL; 
-	Vector<IssmDouble> *U_east_esa    = NULL; 
-	Vector<IssmDouble> *N_gia= NULL; 
-	Vector<IssmDouble> *U_gia= NULL; 
-	Vector<IssmDouble> *N_gia_rate= NULL; 
-	Vector<IssmDouble> *U_gia_rate= NULL; 
-	SealevelMasks* masks=NULL;
-
-	/*parameters:*/
-	bool iscoupler;
-	int  solution_type;
-	int  modelid,earthid;
-	bool istransientmasstransport;
-	int  frequency,count;
-	int  horiz;
-	IssmDouble dt;
-	IssmDouble oceanarea;
-	int        bp_compute_fingerprints=0;
-
-	
-	/*Verbose: */
-	if(VerboseSolution()) _printf0_("	  computing GRD sea level patterns\n");
-
-	/*retrieve more parameters:*/
-	femmodel->parameters->FindParam(&iscoupler,TransientIscouplerEnum);
-	femmodel->parameters->FindParam(&frequency,SolidearthSettingsRunFrequencyEnum);
-	femmodel->parameters->FindParam(&count,SealevelriseRunCountEnum);
+	Vector<IssmDouble> *bedrock  = NULL; 
+	Vector<IssmDouble> *bedrock_rate = NULL;
+	Vector<IssmDouble> *bedrockeast  = NULL; 
+	Vector<IssmDouble> *bedrockeast_rate = NULL;
+	Vector<IssmDouble> *bedrocknorth  = NULL; 
+	Vector<IssmDouble> *bedrocknorth_rate = NULL;
+	Vector<IssmDouble> *geoid= NULL; 
+	Vector<IssmDouble> *geoid_rate= NULL; 
+	int horiz=0;
+	int modelid=-1;
+	int  isexternal=0;
+
+	/*parameters: */
+	IssmDouble          dt;
+
+	/*Retrieve parameters:*/
 	femmodel->parameters->FindParam(&horiz,SolidearthSettingsHorizEnum);
 	femmodel->parameters->FindParam(&dt,TimesteppingTimeStepEnum);
-	femmodel->parameters->FindParam(&solution_type,SolutionTypeEnum);
-
-	if(iscoupler){
+	femmodel->parameters->FindParam(&isexternal,SolidearthIsExternalEnum); 
+
+	/*Early return:*/
+	if (!isexternal)return;
+
+	/*Verbose: */
+	if(VerboseSolution()) _printf0_("	  computing external solid earth contributions\n");
+
+	/*Retrieve geoid viscous and elastic rates, bedrock uplift viscous and elastic rates + steric rate, as vectors:*/
+	GetVectorFromInputsx(&bedrock,femmodel,BedEnum,VertexSIdEnum);
+	GetVectorFromInputsx(&geoid,femmodel,SealevelEnum,VertexSIdEnum); //In ISSM, Sealevel is absolute.
+	if(horiz){
+		GetVectorFromInputsx(&bedrockeast,femmodel,BedEastEnum,VertexSIdEnum);
+		GetVectorFromInputsx(&bedrocknorth,femmodel,BedNorthEnum,VertexSIdEnum);
+	}
+
+	GetVectorFromInputsx(&geoid_rate,femmodel,SolidearthExternalGeoidRateEnum,VertexSIdEnum);
+	GetVectorFromInputsx(&bedrock_rate,femmodel,SolidearthExternalDisplacementUpRateEnum,VertexSIdEnum);
+	if(horiz){
+		GetVectorFromInputsx(&bedrockeast_rate,femmodel,SolidearthExternalDisplacementEastRateEnum,VertexSIdEnum);
+		GetVectorFromInputsx(&bedrocknorth_rate,femmodel,SolidearthExternalDisplacementNorthRateEnum,VertexSIdEnum);
+	}
+
+	/*compute: sea level change = initial sea level + (N_gia_rate+N_esa_rate)  * dt + steric_rate + dynamic_rate dt*/
+	geoid->AXPY(geoid_rate,dt);
+	bedrock->AXPY(bedrock_rate,dt);
+	if(horiz){
+		bedrockeast->AXPY(bedrockeast_rate,dt);
+		bedrocknorth->AXPY(bedrocknorth_rate,dt);
+	}
+
+	/*update element inputs:*/
+	InputUpdateFromVectorx(femmodel,bedrock,BedEnum,VertexSIdEnum);	
+	InputUpdateFromVectorx(femmodel,geoid,SealevelEnum,VertexSIdEnum);	
+	if(horiz){
+		InputUpdateFromVectorx(femmodel,bedrockeast,BedEastEnum,VertexSIdEnum);	
+		InputUpdateFromVectorx(femmodel,bedrocknorth,BedNorthEnum,VertexSIdEnum);	
+	}
+
+	/*Free ressources:*/	
+	delete bedrock; delete bedrock_rate;
+	delete geoid; delete geoid_rate;
+	if(horiz){
+		delete bedrockeast; delete bedrockeast_rate;
+		delete bedrocknorth; delete bedrocknorth_rate;
+	}
+}
+/*}}}*/
+void              couplerinput_core(FemModel* femmodel){  /*{{{*/
+
+	/*Be very careful here, everything is well thought through, do not remove 
+	 * without taking big risks:*/
+
+	/*parameters:*/
+	int  iscoupling;
+	int  modelid,earthid;
+	int  count,frequency;
+	int  horiz;
+
+	/*retrieve more parameters:*/
+	femmodel->parameters->FindParam(&iscoupling,IsSlcCouplingEnum);
+	femmodel->parameters->FindParam(&frequency,SolidearthSettingsRunFrequencyEnum);
+	femmodel->parameters->FindParam(&count,SealevelchangeRunCountEnum);
+
+	if(iscoupling){
 		femmodel->parameters->FindParam(&modelid,ModelIdEnum);
 		femmodel->parameters->FindParam(&earthid,EarthIdEnum);
-		femmodel->parameters->FindParam(&istransientmasstransport,TransientIsmasstransportEnum);
 	}
 	else{
